

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Preprocess &mdash; SmartRecruiting back v2 documentation</title>
  

  
  
  
  

  
  <script type="text/javascript" src="../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
        <script type="text/javascript" src="../_static/jquery.js"></script>
        <script type="text/javascript" src="../_static/underscore.js"></script>
        <script type="text/javascript" src="../_static/doctools.js"></script>
        <script type="text/javascript" src="../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="CNN" href="cnn.html" />
    <link rel="prev" title="Deeplearning" href="deeplearning.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../index.html" class="icon icon-home"> SmartRecruiting back
          

          
          </a>

          
            
            
              <div class="version">
                v2
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../install.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../contributing.html">Contributing</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../documentation.html">Backend documentation</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="deeplearning.html">Deeplearning</a><ul class="current">
<li class="toctree-l3 current"><a class="current reference internal" href="#">Preprocess</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#introduction">Introduction</a></li>
<li class="toctree-l4"><a class="reference internal" href="#todo">TODO</a></li>
<li class="toctree-l4"><a class="reference internal" href="#updates-v2">Updates (v2)</a></li>
<li class="toctree-l4"><a class="reference internal" href="#useful-resources">Useful resources</a></li>
<li class="toctree-l4"><a class="reference internal" href="#code-documentation">Code documentation</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="cnn.html">CNN</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="data.html">Data</a></li>
<li class="toctree-l2"><a class="reference internal" href="api.html">API</a></li>
</ul>
</li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../index.html">SmartRecruiting back</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../documentation.html">Backend documentation</a> &raquo;</li>
        
          <li><a href="deeplearning.html">Deeplearning</a> &raquo;</li>
        
      <li>Preprocess</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../_sources/backend_doc/preprocess.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="module-SmartRecruiting_BackEnd.deeplearning.preprocess">
<span id="preprocess"></span><h1>Preprocess<a class="headerlink" href="#module-SmartRecruiting_BackEnd.deeplearning.preprocess" title="Permalink to this headline">¶</a></h1>
<div class="section" id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>There are three files to handle the offers preprocessing:</p>
<ul class="simple">
<li><cite>preprocess.py</cite> to handle preprocess operations on offers : transform the offers CSV file to list of offers which
each offers is a list of word descriptor. A word descriptor is a vector of float numbers.</li>
<li><cite>database_handler.py</cite> to perform database operations : add or update the database (offers, fields, contacts)</li>
<li><cite>utils.py</cite> to visualize the words descriptor of our model vocabulary</li>
</ul>
</div>
<div class="section" id="todo">
<h2>TODO<a class="headerlink" href="#todo" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li>Implement unit testing on <cite>database_handler.py</cite> and complete the two last functions to do in <cite>test_preprocess.py</cite></li>
<li>Try to find (or build) a french texts corpus more recent (actually it’s wikipedia pages from 2008)</li>
<li>Review functions in <cite>database_handler</cite></li>
</ul>
</div>
<div class="section" id="updates-v2">
<h2>Updates (v2)<a class="headerlink" href="#updates-v2" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li>Unit tests on <cite>preprocess.py</cite>. Unit tests <cite>test_preprocess_all_and_add_to_database</cite> and <cite>test_recompute_all_descriptors</cite> are not yet done because this functions calls database function, it’s more complicated. For <cite>test_preprocess_all_and_add_to_database</cite>  we write some tests but it’s commented ;</li>
<li>Train word2vec model on Wikipedia corpus. You can see, below, the improvement thanks to this new training set. We used a list a words to plot to improve the graph readability:</li>
<li>Add <cite>utils.py</cite> and a function to visualize our model vocabulary word representation ;</li>
<li>Improve natural language tokenization on words (stemming, tokenization, punctuation). In particular we used NLTK library and regex to achieve a good tokenization ;</li>
<li>Move database operations in <cite>database_handler.py</cite> file (now there are two files in preprocess, see above to know how it works) ;</li>
<li>Remove duplicate code, improve readability and refactor code to improve the cognitive complexity ;</li>
<li>Refactor style code to PEP8 and documenting functions. See contributing file or documentation to know more about our conventions.</li>
</ul>
</div>
<div class="section" id="useful-resources">
<h2>Useful resources<a class="headerlink" href="#useful-resources" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li>[Text Preprocessing in Python](<a class="reference external" href="https://medium.com/&#64;datamonsters/text-preprocessing-in-python-steps-tools-and-examples-bf025f872908">https://medium.com/&#64;datamonsters/text-preprocessing-in-python-steps-tools-and-examples-bf025f872908</a>)</li>
<li>[Visualizing Word Vectors with t-SNE](<a class="reference external" href="https://www.kaggle.com/jeffd23/visualizing-word-vectors-with-t-sne">https://www.kaggle.com/jeffd23/visualizing-word-vectors-with-t-sne</a>)</li>
<li>[word2vec google homepage](<a class="reference external" href="https://code.google.com/archive/p/word2vec/">https://code.google.com/archive/p/word2vec/</a>)</li>
</ul>
</div>
<div class="section" id="code-documentation">
<h2>Code documentation<a class="headerlink" href="#code-documentation" title="Permalink to this headline">¶</a></h2>
<div class="section" id="module-SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess">
<span id="preprocess-py"></span><h3><code class="docutils literal notranslate"><span class="pre">preprocess.py</span></code><a class="headerlink" href="#module-SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess" title="Permalink to this headline">¶</a></h3>
<p>Preprocessing of texts, using the removal of stop words and the Word2Vec to create descriptors.</p>
<p>Text descriptor format : python list (size = config) of numpy array (size = config)</p>
<p>Wikipedia FR corpus (2008) : <a class="reference external" href="http://redac.univ-tlse2.fr/corpora/wikipedia_en.html">http://redac.univ-tlse2.fr/corpora/wikipedia_en.html</a>
Stats :
- Nb words : 284 472 742
- Nb lines : 37 654 166</p>
<dl class="function">
<dt id="SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.build_word2vec">
<code class="descclassname">SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.</code><code class="descname">build_word2vec</code><span class="sig-paren">(</span><em>offers=None</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/preprocess/preprocess.html#build_word2vec"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.build_word2vec" title="Permalink to this definition">¶</a></dt>
<dd><p>This function builds a Word2Vec neural network model. This model produces vector for each word in our vocabulary.
Word2vec also build our vocabulary with our [sentences].</p>
<p>This model will be trained on wikipedia corpus and offers :</p>
<ul class="simple">
<li>from the offers csv file if offers is null</li>
<li>from the [offers] parameter else</li>
</ul>
<p>Offers csv filename and wikipedia corpus filename are defined in the config file.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Word2vec model parameters can be changed in the config file.</p>
</div>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">We have also add a padding words in the vocabulary to be able to pad texts with this word</p>
</div>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>offers</strong> – (optional) offers used to train the model (else, offers from the CSV used)</td>
</tr>
<tr class="field-even field"><th class="field-name">Type:</th><td class="field-body">list of dictionary with at least {‘content: str }</td>
</tr>
<tr class="field-odd field"><th class="field-name">Returns:</th><td class="field-body">Word2Vec model trained on [sentences]</td>
</tr>
<tr class="field-even field"><th class="field-name">Return type:</th><td class="field-body">Word2Vec</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.get_wikipedia_corpus">
<code class="descclassname">SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.</code><code class="descname">get_wikipedia_corpus</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/preprocess/preprocess.html#get_wikipedia_corpus"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.get_wikipedia_corpus" title="Permalink to this definition">¶</a></dt>
<dd><p>Get content from the wikipedia corpus (filename specified in config file).
This function read the corpus text file, and add lines to the result. A limit can be specified in the config
file to not process all lines.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Returns:</th><td class="field-body">list containing lines from the wikipedia corpus</td>
</tr>
<tr class="field-even field"><th class="field-name">Return type:</th><td class="field-body">list of str</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.init">
<code class="descclassname">SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.</code><code class="descname">init</code><span class="sig-paren">(</span><em>db_manager</em>, <em>generate_w2c=False</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/preprocess/preprocess.html#init"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.init" title="Permalink to this definition">¶</a></dt>
<dd><p>Function to initialize the model and the database.
Has to be called before using the CNN model for the first time or if the csv files (offers, fields, contacts) has changed</p>
<p>Populate the database with:
- offers with their word descriptor
- fields
- contacts</p>
<p>If generate_w2c if set to True, the word2vec model is build and train.</p>
<p>If you run the app with runserver :
- Use –init arg to launch this function
- Use –word2vec arg to set this flag</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>db_manager</strong> (<a class="reference internal" href="managers.html#SmartRecruiting_BackEnd.data.manager.DatabaseManager" title="SmartRecruiting_BackEnd.data.manager.DatabaseManager"><em>DatabaseManager</em></a>) – database manager</li>
<li><strong>generate_w2c</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.7)"><em>bool</em></a>) – (optional) True if word2vec model have to be build and train</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.load_word2vec">
<code class="descclassname">SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.</code><code class="descname">load_word2vec</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/preprocess/preprocess.html#load_word2vec"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.load_word2vec" title="Permalink to this definition">¶</a></dt>
<dd><p>Load the word2vec model from the file defined in the config file.
If an error occurred (typically the file doesn’t exists) we exit the execution.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">If want want to build the word2vec model consider using the build_word2vec method.</p>
</div>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Returns:</th><td class="field-body">The word2vec model</td>
</tr>
<tr class="field-even field"><th class="field-name">Return type:</th><td class="field-body">Word2Vec</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.preprocess">
<code class="descclassname">SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.</code><code class="descname">preprocess</code><span class="sig-paren">(</span><em>text</em>, <em>model</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/preprocess/preprocess.html#preprocess"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.preprocess" title="Permalink to this definition">¶</a></dt>
<dd><p>Function to get a text descriptor from the [text]. Following steps are done :
1. Tokenize text (see tokenize function)
2. Normalization of the [text] lenght (padding or truncating)
3. From the vocabulary of our Word2Vec model, we get the words representations</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>text</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.7)"><em>str</em></a>) – the input text</li>
<li><strong>model</strong> (<em>Word2Vec</em>) – word2vec model which contains words and words descriptor</li>
</ul>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first">Word representations (each word is a float numpy array)</p>
</td>
</tr>
<tr class="field-odd field"><th class="field-name">Return type:</th><td class="field-body"><p class="first last">list of numpy array</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.preprocess_all_and_add_to_database">
<code class="descclassname">SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.</code><code class="descname">preprocess_all_and_add_to_database</code><span class="sig-paren">(</span><em>db_manager</em>, <em>file_name</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/preprocess/preprocess.html#preprocess_all_and_add_to_database"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.preprocess_all_and_add_to_database" title="Permalink to this definition">¶</a></dt>
<dd><p>Function to preprocess the offers from a csv film [file_name] and add them in the database.
See preprocess function to know more about the preprocess operations.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>file_name</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.7)"><em>str</em></a>) – name of the file containing the data to process</li>
<li><strong>db_manager</strong> – database manager</li>
</ul>
</td>
</tr>
<tr class="field-even field"><th class="field-name" colspan="2">Rtype db_manager:</th></tr>
<tr class="field-even field"><td>&#160;</td><td class="field-body"><p class="first last">DatabaseManager</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.tokenize">
<code class="descclassname">SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.</code><code class="descname">tokenize</code><span class="sig-paren">(</span><em>text</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/preprocess/preprocess.html#tokenize"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.tokenize" title="Permalink to this definition">¶</a></dt>
<dd><p>Function  to tokenize the [text]. Following steps are done to tokenize the [text] :
1. Lowercase + remove whitespaces
2. Keep only numbers
3. Remove punctuations
4. Tokenize the text into words
5. For each word, if it is not in stopwords list, we add the stem of the word to the return result</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>text</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.7)"><em>str</em></a>) – input text to tokenize</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body">list of words</td>
</tr>
<tr class="field-odd field"><th class="field-name">Return type:</th><td class="field-body">list of str</td>
</tr>
</tbody>
</table>
</dd></dl>

</div>
<div class="section" id="module-SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler">
<span id="database-handler-py"></span><h3><code class="docutils literal notranslate"><span class="pre">database_handler.py</span></code><a class="headerlink" href="#module-SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler" title="Permalink to this headline">¶</a></h3>
<p>TODO: Not yet review.
TODO/ finish to do the documentation</p>
<dl class="function">
<dt id="SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.add_an_offer">
<code class="descclassname">SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.</code><code class="descname">add_an_offer</code><span class="sig-paren">(</span><em>db_manager</em>, <em>offer</em>, <em>id_admin</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/preprocess/database_handler.html#add_an_offer"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.add_an_offer" title="Permalink to this definition">¶</a></dt>
<dd><p>Add a preprocessed offer in the database</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>offer</strong> – (text,descriptor,label) the processed offer</li>
<li><strong>db_manager</strong> (<a class="reference internal" href="managers.html#SmartRecruiting_BackEnd.data.manager.DatabaseManager" title="SmartRecruiting_BackEnd.data.manager.DatabaseManager"><em>DatabaseManager</em></a>) – database manager</li>
</ul>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Type:</th><td class="field-body"></td>
</tr>
</tbody>
</table>
<p>:param id_admin;
:type:</p>
<p>:return the id of the newly created offer
:rtype int</p>
</dd></dl>

<dl class="function">
<dt id="SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.add_contact">
<code class="descclassname">SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.</code><code class="descname">add_contact</code><span class="sig-paren">(</span><em>db_manager</em>, <em>field_name</em>, <em>name</em>, <em>surname</em>, <em>role</em>, <em>email</em>, <em>phone</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/preprocess/database_handler.html#add_contact"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.add_contact" title="Permalink to this definition">¶</a></dt>
<dd><p>Insert contact in the database</p>
<p>:param db_manager
:param field_name
:param name
:param surname
:param role
:param email
:param phone</p>
</dd></dl>

<dl class="function">
<dt id="SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.add_contacts">
<code class="descclassname">SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.</code><code class="descname">add_contacts</code><span class="sig-paren">(</span><em>db_manager</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/preprocess/database_handler.html#add_contacts"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.add_contacts" title="Permalink to this definition">¶</a></dt>
<dd><table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>db_manager</strong> (<a class="reference internal" href="managers.html#SmartRecruiting_BackEnd.data.manager.DatabaseManager" title="SmartRecruiting_BackEnd.data.manager.DatabaseManager"><em>DatabaseManager</em></a>) – database_manager</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.add_offer_to_database">
<code class="descclassname">SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.</code><code class="descname">add_offer_to_database</code><span class="sig-paren">(</span><em>db_manager</em>, <em>offer</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/preprocess/database_handler.html#add_offer_to_database"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.add_offer_to_database" title="Permalink to this definition">¶</a></dt>
<dd><p>Add one preprocessed offer in the database</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>db_manager</strong> – database manager</li>
<li><strong>offer</strong> – list of (text,descriptor,label)</li>
</ul>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Type:</th><td class="field-body"><p class="first"><a class="reference internal" href="managers.html#SmartRecruiting_BackEnd.data.manager.DatabaseManager" title="SmartRecruiting_BackEnd.data.manager.DatabaseManager">DatabaseManager</a></p>
</td>
</tr>
<tr class="field-odd field"><th class="field-name">Rtype offer:</th><td class="field-body"></td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.get_id_field">
<code class="descclassname">SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.</code><code class="descname">get_id_field</code><span class="sig-paren">(</span><em>db_manager</em>, <em>name</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/preprocess/database_handler.html#get_id_field"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.get_id_field" title="Permalink to this definition">¶</a></dt>
<dd><p>Add id of the named field or create the field and get the id if the field doesn’t exist</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>db_manager</strong> (<a class="reference internal" href="managers.html#SmartRecruiting_BackEnd.data.manager.DatabaseManager" title="SmartRecruiting_BackEnd.data.manager.DatabaseManager"><em>DatabaseManager</em></a>) – database manager</li>
<li><strong>name</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.7)"><em>str</em></a>) – name of the field</li>
</ul>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first">id of the offer if successful, -1 if not</p>
</td>
</tr>
<tr class="field-odd field"><th class="field-name">Return type:</th><td class="field-body"><p class="first last"><a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.7)">int</a></p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.set_field_information">
<code class="descclassname">SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.</code><code class="descname">set_field_information</code><span class="sig-paren">(</span><em>db_manager</em>, <em>name</em>, <em>description</em>, <em>website</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/preprocess/database_handler.html#set_field_information"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.preprocess.database_handler.set_field_information" title="Permalink to this definition">¶</a></dt>
<dd><p>Set information for the field name</p>
<p>:param db_manager
:param name : name of the field to update
:param description
:param website</p>
</dd></dl>

</div>
<div class="section" id="module-SmartRecruiting_BackEnd.deeplearning.preprocess.utils">
<span id="utils-py"></span><h3><code class="docutils literal notranslate"><span class="pre">utils.py</span></code><a class="headerlink" href="#module-SmartRecruiting_BackEnd.deeplearning.preprocess.utils" title="Permalink to this headline">¶</a></h3>
<p>Utils function used in preprocess. Please see the documentation of each function.</p>
<dl class="function">
<dt id="SmartRecruiting_BackEnd.deeplearning.preprocess.utils.plot">
<code class="descclassname">SmartRecruiting_BackEnd.deeplearning.preprocess.utils.</code><code class="descname">plot</code><span class="sig-paren">(</span><em>model</em>, <em>max_words=100</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/preprocess/utils.html#plot"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.preprocess.utils.plot" title="Permalink to this definition">¶</a></dt>
<dd><p>Inspired by kaggle tutorial : <a class="reference external" href="https://www.kaggle.com/jeffd23/visualizing-word-vectors-with-t-sne">https://www.kaggle.com/jeffd23/visualizing-word-vectors-with-t-sne</a></p>
<p>This functions plot in a 2D space the words descriptor of the words of the model vocabulary.</p>
<p>Initially, words descriptor are vector of a higher dimension than 2 (see the config file to know exactly the
dimension). This function use[t-SNE](<a class="reference external" href="https://en.wikipedia.org/wiki/T-distributed_stochastic_neighbor_embedding">https://en.wikipedia.org/wiki/T-distributed_stochastic_neighbor_embedding</a>)
machine learning algorithm.</p>
<p>From wikipedia :
&gt; It (t-SNE) is a nonlinear dimensionality reduction technique well-suited for embedding high-dimensional data for
visualization in a low-dimensional space of two or three dimensions</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>model</strong> (<em>Word2Vec</em>) – word2vec model containing the vocabulary with words descriptor</li>
<li><strong>max_words</strong> – (optional) max words to plot</li>
</ul>
</td>
</tr>
<tr class="field-even field"><th class="field-name" colspan="2">Rtype max_words:</th></tr>
<tr class="field-even field"><td>&#160;</td><td class="field-body"><p class="first last">int</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

</div>
</div>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="cnn.html" class="btn btn-neutral float-right" title="CNN" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="deeplearning.html" class="btn btn-neutral float-left" title="Deeplearning" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, Projet 21

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>